diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/system-path.cc ns-3.42/src/core/model/system-path.cc
--- ns-3.41/src/core/model/system-path.cc	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/system-path.cc	2024-05-29 15:29:46.936073000 -0700
@@ -26,31 +26,11 @@
 
 #include <algorithm>
 #include <ctime>
+#include <filesystem>
 #include <regex>
 #include <sstream>
 #include <tuple>
 
-// Some compilers such as GCC < 8 (Ubuntu 18.04
-// ships with GCC 7) do not ship with the
-// std::filesystem header,  but with the
-// std::experimental::filesystem header.
-// Since Clang reuses these headers and the libstdc++
-// from GCC, we need to either use the experimental
-// version or require a more up-to-date GCC.
-// we use the "fs" namespace to prevent collisions
-// with musl libc.
-#ifdef __has_include
-#if __has_include(<filesystem>)
-#include <filesystem>
-namespace fs = std::filesystem;
-#elif __has_include(<experimental/filesystem>)
-#include <experimental/filesystem>
-namespace fs = std::experimental::filesystem;
-#else
-#error "No support for filesystem library"
-#endif
-#endif
-
 #ifdef __APPLE__
 #include <mach-o/dyld.h>
 #endif /* __APPLE__ */
@@ -107,13 +87,13 @@
 {
     NS_LOG_FUNCTION(path);
     std::list<std::string> files;
-    if (!fs::exists(path))
+    if (!std::filesystem::exists(path))
     {
         return std::make_tuple(files, true);
     }
-    for (auto& it : fs::directory_iterator(path))
+    for (auto& it : std::filesystem::directory_iterator(path))
     {
-        if (!fs::is_directory(it.path()))
+        if (!std::filesystem::is_directory(it.path()))
         {
             files.push_back(it.path().filename().string());
         }
@@ -189,7 +169,7 @@
     {
         //  LPTSTR = char *
         DWORD size = 1024;
-        LPTSTR lpFilename = (LPTSTR)malloc(sizeof(TCHAR) * size);
+        auto lpFilename = (LPTSTR)malloc(sizeof(TCHAR) * size);
         DWORD status = GetModuleFileName(nullptr, lpFilename, size);
         while (status == size)
         {
@@ -352,9 +332,9 @@
     NS_LOG_FUNCTION(path);
 
     std::error_code ec;
-    if (!fs::exists(path))
+    if (!std::filesystem::exists(path))
     {
-        fs::create_directories(path, ec);
+        std::filesystem::create_directories(path, ec);
     }
 
     if (ec.value())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/test.cc ns-3.42/src/core/model/test.cc
--- ns-3.41/src/core/model/test.cc	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/test.cc	2024-05-29 15:29:46.936073000 -0700
@@ -19,6 +19,7 @@
 
 #include "abort.h"
 #include "assert.h"
+#include "config.h"
 #include "des-metrics.h"
 #include "log.h"
 #include "singleton.h"
@@ -238,7 +239,7 @@
      */
     std::list<TestCase*> FilterTests(std::string testName,
                                      TestSuite::Type testType,
-                                     TestCase::TestDuration maximumTestDuration);
+                                     TestCase::Duration maximumTestDuration);
 
     /** Container type for the test. */
     typedef std::vector<TestSuite*> TestSuiteVector;
@@ -279,7 +280,7 @@
       m_runner(nullptr),
       m_result(nullptr),
       m_name(name),
-      m_duration(TestCase::QUICK)
+      m_duration(TestCase::Duration::QUICK)
 {
     NS_LOG_FUNCTION(this << name);
 }
@@ -298,7 +299,7 @@
 }
 
 void
-TestCase::AddTestCase(TestCase* testCase, TestCase::TestDuration duration)
+TestCase::AddTestCase(TestCase* testCase, TestCase::Duration duration)
 {
     NS_LOG_FUNCTION(&testCase << duration);
 
@@ -351,6 +352,7 @@
     NS_LOG_FUNCTION(this << runner);
     m_result = new Result();
     m_runner = runner;
+    Config::Reset();
     DoSetup();
     m_result->clock.Start();
     for (auto i = m_children.begin(); i != m_children.end(); ++i)
@@ -366,6 +368,7 @@
 out:
     m_result->clock.End();
     DoTeardown();
+    Config::Reset();
     m_runner = nullptr;
 }
 
@@ -796,11 +799,11 @@
     NS_LOG_FUNCTION(this << &begin << &end << printTestType);
     std::map<TestSuite::Type, std::string> label;
 
-    label[TestSuite::ALL] = "all          ";
-    label[TestSuite::UNIT] = "unit         ";
-    label[TestSuite::SYSTEM] = "system       ";
-    label[TestSuite::EXAMPLE] = "example      ";
-    label[TestSuite::PERFORMANCE] = "performance  ";
+    label[TestSuite::Type::ALL] = "all          ";
+    label[TestSuite::Type::UNIT] = "unit         ";
+    label[TestSuite::Type::SYSTEM] = "system       ";
+    label[TestSuite::Type::EXAMPLE] = "example      ";
+    label[TestSuite::Type::PERFORMANCE] = "performance  ";
 
     for (auto i = begin; i != end; ++i)
     {
@@ -833,14 +836,14 @@
 std::list<TestCase*>
 TestRunnerImpl::FilterTests(std::string testName,
                             TestSuite::Type testType,
-                            TestCase::TestDuration maximumTestDuration)
+                            TestCase::Duration maximumTestDuration)
 {
     NS_LOG_FUNCTION(this << testName << testType);
     std::list<TestCase*> tests;
     for (uint32_t i = 0; i < m_suites.size(); ++i)
     {
         TestSuite* test = m_suites[i];
-        if (testType != TestSuite::ALL && test->GetTestType() != testType)
+        if (testType != TestSuite::Type::ALL && test->GetTestType() != testType)
         {
             // skip test
             continue;
@@ -894,7 +897,7 @@
     bool printTestTypeList = false;
     bool printTestNameList = false;
     bool printTestTypeAndName = false;
-    TestCase::TestDuration maximumTestDuration = TestCase::QUICK;
+    TestCase::Duration maximumTestDuration = TestCase::Duration::QUICK;
     char* progname = argv[0];
 
     char** argi = argv;
@@ -924,11 +927,6 @@
         {
             m_updateData = true;
         }
-        else if (arg == "--help")
-        {
-            PrintHelp(progname);
-            return 0;
-        }
         else if (arg == "--print-test-name-list" || arg == "--list")
         {
             printTestNameList = true;
@@ -953,11 +951,8 @@
         {
             testTypeString = arg.substr(arg.find_first_of('=') + 1);
         }
-        else if (arg.find("--test-name=") != std::string::npos)
-        {
-            testName = arg.substr(arg.find_first_of('=') + 1);
-        }
-        else if (arg.find("--suite=") != std::string::npos)
+        else if (arg.find("--test-name=") != std::string::npos ||
+                 arg.find("--suite=") != std::string::npos)
         {
             testName = arg.substr(arg.find_first_of('=') + 1);
         }
@@ -976,15 +971,15 @@
             // Set the maximum test length allowed.
             if (fullness == "QUICK")
             {
-                maximumTestDuration = TestCase::QUICK;
+                maximumTestDuration = TestCase::Duration::QUICK;
             }
             else if (fullness == "EXTENSIVE")
             {
-                maximumTestDuration = TestCase::EXTENSIVE;
+                maximumTestDuration = TestCase::Duration::EXTENSIVE;
             }
             else if (fullness == "TAKES_FOREVER")
             {
-                maximumTestDuration = TestCase::TAKES_FOREVER;
+                maximumTestDuration = TestCase::Duration::TAKES_FOREVER;
             }
             else
             {
@@ -995,36 +990,32 @@
         }
         else
         {
-            // un-recognized command-line argument
+            // Print the help if arg == "--help" or arg is an un-recognized command-line argument
             PrintHelp(progname);
             return 0;
         }
         argi++;
     }
     TestSuite::Type testType;
-    if (testTypeString.empty())
+    if (testTypeString.empty() || testTypeString == "core")
     {
-        testType = TestSuite::ALL;
-    }
-    else if (testTypeString == "core")
-    {
-        testType = TestSuite::ALL;
+        testType = TestSuite::Type::ALL;
     }
     else if (testTypeString == "example")
     {
-        testType = TestSuite::EXAMPLE;
+        testType = TestSuite::Type::EXAMPLE;
     }
     else if (testTypeString == "unit")
     {
-        testType = TestSuite::UNIT;
+        testType = TestSuite::Type::UNIT;
     }
     else if (testTypeString == "system")
     {
-        testType = TestSuite::SYSTEM;
+        testType = TestSuite::Type::SYSTEM;
     }
     else if (testTypeString == "performance")
     {
-        testType = TestSuite::PERFORMANCE;
+        testType = TestSuite::Type::PERFORMANCE;
     }
     else
     {
@@ -1144,4 +1135,38 @@
     return TestRunnerImpl::Get()->Run(argc, argv);
 }
 
+std::ostream&
+operator<<(std::ostream& os, TestSuite::Type type)
+{
+    switch (type)
+    {
+    case TestSuite::Type::ALL:
+        return os << "ALL";
+    case TestSuite::Type::UNIT:
+        return os << "UNIT";
+    case TestSuite::Type::SYSTEM:
+        return os << "SYSTEM";
+    case TestSuite::Type::EXAMPLE:
+        return os << "EXAMPLE";
+    case TestSuite::Type::PERFORMANCE:
+        return os << "PERFORMANCE";
+    };
+    return os << "UNKNOWN(" << static_cast<uint32_t>(type) << ")";
+}
+
+std::ostream&
+operator<<(std::ostream& os, TestCase::Duration duration)
+{
+    switch (duration)
+    {
+    case TestCase::Duration::QUICK:
+        return os << "QUICK";
+    case TestCase::Duration::EXTENSIVE:
+        return os << "EXTENSIVE";
+    case TestCase::Duration::TAKES_FOREVER:
+        return os << "TAKES_FOREVER";
+    };
+    return os << "UNKNOWN(" << static_cast<uint32_t>(duration) << ")";
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/test.h ns-3.42/src/core/model/test.h
--- ns-3.41/src/core/model/test.h	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/test.h	2024-05-29 15:29:46.936073000 -0700
@@ -18,6 +18,7 @@
 #ifndef NS3_TEST_H
 #define NS3_TEST_H
 
+#include "deprecated.h"
 #include "system-wall-clock-ms.h"
 
 #include <fstream>
@@ -1060,13 +1061,24 @@
 {
   public:
     /** \brief How long the test takes to execute. */
-    enum TestDuration
+    enum class Duration
     {
         QUICK = 1,        //!< Fast test.
         EXTENSIVE = 2,    //!< Medium length test.
         TAKES_FOREVER = 3 //!< Very long running test.
     };
 
+    NS_DEPRECATED_3_42("Use Duration::QUICK instead")
+    static constexpr auto QUICK = Duration::QUICK; //!< @deprecated See Duration::QUICK.
+    NS_DEPRECATED_3_42("Use Duration::EXTENSIVE instead")
+    static constexpr auto EXTENSIVE = Duration::EXTENSIVE; //!< @deprecated See Duration::EXTENSIVE.
+    NS_DEPRECATED_3_42("Use Duration::TAKES_FOREVER instead")
+    static constexpr auto TAKES_FOREVER =
+        Duration::TAKES_FOREVER; //!< @deprecated See Duration::TAKES_FOREVER.
+
+    using TestDuration NS_DEPRECATED_3_42("Use Duration instead") =
+        Duration; //!< @deprecated See Duration.
+
     /**
      *  Destructor
      */
@@ -1096,7 +1108,7 @@
      * \param [in] duration Amount of time this test takes to execute
      *             (defaults to QUICK).
      */
-    void AddTestCase(TestCase* testCase, TestDuration duration = QUICK);
+    void AddTestCase(TestCase* testCase, Duration duration = Duration::QUICK);
 
     /**
      * \brief Set the data directory where reference trace files can be
@@ -1222,7 +1234,12 @@
 
     // methods called by TestRunnerImpl
     /**
-     * \brief Actually run this TestCase
+     * \brief Executes DoSetup(), DoRun(), and DoTeardown() for the TestCase
+     *
+     * Config::Reset() is called at both the beginning and end of this method
+     * so that any changes to attribute default values (Config::SetDefault(...))
+     * or global values (e.g., RngRun) that are made within the test case's
+     * DoRun() method do not propagate beyond the scope of running the TestCase.
      *
      * \param [in] runner The test runner implementation.
      */
@@ -1242,7 +1259,7 @@
     TestRunnerImpl* m_runner;          //!< Pointer to the TestRunner
     Result* m_result;                  //!< Results data
     std::string m_name;                //!< TestCase name
-    TestDuration m_duration;           //!< TestCase duration
+    Duration m_duration;               //!< TestCase duration
 };
 
 /**
@@ -1259,7 +1276,7 @@
      * \enum Type
      * \brief Type of test.
      */
-    enum Type
+    enum class Type
     {
         ALL = 0,    //!<
         UNIT,       //!< This test suite implements a Unit Test
@@ -1268,13 +1285,24 @@
         PERFORMANCE //!< This test suite implements a Performance Test
     };
 
+    NS_DEPRECATED_3_42("Use Type::ALL instead")
+    static constexpr auto ALL = Type::ALL; //!< @deprecated See Type::ALL.
+    NS_DEPRECATED_3_42("Use Type::UNIT instead")
+    static constexpr auto UNIT = Type::UNIT; //!< @deprecated See Type::UNIT.
+    NS_DEPRECATED_3_42("Use Type::SYSTEM instead")
+    static constexpr auto SYSTEM = Type::SYSTEM; //!< @deprecated See Type::SYSTEM.
+    NS_DEPRECATED_3_42("Use Type::EXAMPLE instead")
+    static constexpr auto EXAMPLE = Type::EXAMPLE; //!< @deprecated See Type::EXAMPLE.
+    NS_DEPRECATED_3_42("Use Type::PERFORMANCE instead")
+    static constexpr auto PERFORMANCE = Type::PERFORMANCE; //!< @deprecated See Type::PERFORMANCE.
+
     /**
      * \brief Construct a new test suite.
      *
      * \param [in] name The name of the test suite.
      * \param [in] type The TestType of the test suite (defaults to UNIT test).
      */
-    TestSuite(std::string name, Type type = UNIT);
+    TestSuite(std::string name, Type type = Type::UNIT);
 
     /**
      * \brief get the kind of test this test suite implements
@@ -1357,6 +1385,38 @@
      */
     T Get(std::size_t i) const;
 
+    /**
+     * \return The underlying data structure begin iterator
+     */
+    typename std::vector<T>::iterator begin()
+    {
+        return m_vectors.begin();
+    }
+
+    /**
+     * \return The underlying data structure end iterator
+     */
+    typename std::vector<T>::iterator end()
+    {
+        return m_vectors.end();
+    }
+
+    /**
+     * \return The underlying data structure const begin iterator
+     */
+    typename std::vector<T>::const_iterator begin() const
+    {
+        return m_vectors.begin();
+    }
+
+    /**
+     * \return The underlying data structure const end iterator
+     */
+    typename std::vector<T>::const_iterator end() const
+    {
+        return m_vectors.end();
+    }
+
   private:
     typedef std::vector<T> TestVector; //!< Container type
     TestVector m_vectors;              //!< The list of test vectors
@@ -1404,6 +1464,22 @@
     return m_vectors[i];
 }
 
+/**
+ * @brief Stream insertion operator.
+ * @param [in] os The reference to the output stream.
+ * @param [in] type The TestSuite::Type.
+ * @return The reference to the output stream.
+ */
+std::ostream& operator<<(std::ostream& os, TestSuite::Type type);
+
+/**
+ * @brief Stream insertion operator.
+ * @param [in] os The reference to the output stream.
+ * @param [in] duration The TestCase::Duration.
+ * @return The reference to the output stream.
+ */
+std::ostream& operator<<(std::ostream& os, TestCase::Duration duration);
+
 } // namespace ns3
 
 #endif /* NS3_TEST_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/timer.cc ns-3.42/src/core/model/timer.cc
--- ns-3.41/src/core/model/timer.cc	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/timer.cc	2024-05-29 15:29:46.936073000 -0700
@@ -56,7 +56,7 @@
     NS_LOG_FUNCTION(this);
     if (m_flags & CHECK_ON_DESTROY)
     {
-        if (m_event.IsRunning())
+        if (m_event.IsPending())
         {
             NS_FATAL_ERROR("Event is still running while destroying.");
         }
@@ -129,7 +129,7 @@
 Timer::IsRunning() const
 {
     NS_LOG_FUNCTION(this);
-    return !IsSuspended() && m_event.IsRunning();
+    return !IsSuspended() && m_event.IsPending();
 }
 
 bool
@@ -170,7 +170,7 @@
 {
     NS_LOG_FUNCTION(this << delay);
     NS_ASSERT(m_impl != nullptr);
-    if (m_event.IsRunning())
+    if (m_event.IsPending())
     {
         NS_FATAL_ERROR("Event is still running while re-scheduling.");
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/timer.h ns-3.42/src/core/model/timer.h
--- ns-3.41/src/core/model/timer.h	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/timer.h	2024-05-29 15:29:46.936073000 -0700
@@ -21,7 +21,6 @@
 
 #include "event-id.h"
 #include "fatal-error.h"
-#include "int-to-type.h"
 #include "nstime.h"
 
 /**
@@ -50,8 +49,13 @@
  * Timer is destroyed.
  */
 
+namespace internal
+{
+
 class TimerImpl;
 
+} // namespace internal
+
 /**
  * \ingroup timer
  * \brief A simple virtual Timer class
@@ -254,7 +258,7 @@
      * The timer implementation, which contains the bound callback
      * function and arguments.
      */
-    TimerImpl* m_impl;
+    internal::TimerImpl* m_impl;
     /** The amount of time left on the Timer while it is suspended. */
     Time m_delayLeft;
 };
@@ -275,7 +279,7 @@
 Timer::SetFunction(FN fn)
 {
     delete m_impl;
-    m_impl = MakeTimerImpl(fn);
+    m_impl = internal::MakeTimerImpl(fn);
 }
 
 template <typename MEM_PTR, typename OBJ_PTR>
@@ -283,7 +287,7 @@
 Timer::SetFunction(MEM_PTR memPtr, OBJ_PTR objPtr)
 {
     delete m_impl;
-    m_impl = MakeTimerImpl(memPtr, objPtr);
+    m_impl = internal::MakeTimerImpl(memPtr, objPtr);
 }
 
 template <typename... Ts>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/model/timer-impl.h ns-3.42/src/core/model/timer-impl.h
--- ns-3.41/src/core/model/timer-impl.h	2024-02-09 14:44:07.885789900 -0800
+++ ns-3.42/src/core/model/timer-impl.h	2024-05-29 15:29:46.936073000 -0700
@@ -21,9 +21,9 @@
 #define TIMER_IMPL_H
 
 #include "fatal-error.h"
-#include "int-to-type.h"
 #include "simulator.h"
-#include "type-traits.h"
+
+#include <type_traits>
 
 /**
  * \file
@@ -35,6 +35,9 @@
 namespace ns3
 {
 
+namespace internal
+{
+
 /**
  * \ingroup timer
  * The timer implementation underlying Timer and Watchdog.
@@ -49,75 +52,12 @@
 
     /**
      * Set the arguments to be used when invoking the expire function.
+     *
+     * \tparam Args \deduced Type template parameter pack
+     * \param [in] args The arguments to pass to the invoked method
      */
-    /**@{*/
-    /**
-     * \tparam T1 \deduced Type of the first argument.
-     * \param [in] a1 The first argument
-     */
-    template <typename T1>
-    void SetArgs(T1 a1);
-    /**
-     * \tparam T1 \deduced Type of the first argument.
-     * \tparam T2 \deduced Type of the second argument.
-     * \param [in] a1 the first argument
-     * \param [in] a2 the second argument
-     */
-    template <typename T1, typename T2>
-    void SetArgs(T1 a1, T2 a2);
-    /**
-     * \tparam T1 \deduced Type of the first argument.
-     * \tparam T2 \deduced Type of the second argument.
-     * \tparam T3 \deduced Type of the third argument.
-     * \param [in] a1 the first argument
-     * \param [in] a2 the second argument
-     * \param [in] a3 the third argument
-     */
-    template <typename T1, typename T2, typename T3>
-    void SetArgs(T1 a1, T2 a2, T3 a3);
-    /**
-     * \tparam T1 \deduced Type of the first argument.
-     * \tparam T2 \deduced Type of the second argument.
-     * \tparam T3 \deduced Type of the third argument.
-     * \tparam T4 \deduced Type of the fourth argument.
-     * \param [in] a1 the first argument
-     * \param [in] a2 the second argument
-     * \param [in] a3 the third argument
-     * \param [in] a4 the fourth argument
-     */
-    template <typename T1, typename T2, typename T3, typename T4>
-    void SetArgs(T1 a1, T2 a2, T3 a3, T4 a4);
-    /**
-     * \tparam T1 \deduced Type of the first argument.
-     * \tparam T2 \deduced Type of the second argument.
-     * \tparam T3 \deduced Type of the third argument.
-     * \tparam T4 \deduced Type of the fourth argument.
-     * \tparam T5 \deduced Type of the fifth argument.
-     * \param [in] a1 the first argument
-     * \param [in] a2 the second argument
-     * \param [in] a3 the third argument
-     * \param [in] a4 the fourth argument
-     * \param [in] a5 the fifth argument
-     */
-    template <typename T1, typename T2, typename T3, typename T4, typename T5>
-    void SetArgs(T1 a1, T2 a2, T3 a3, T4 a4, T5 a5);
-    /**
-     * \tparam T1 \deduced Type of the first argument.
-     * \tparam T2 \deduced Type of the second argument.
-     * \tparam T3 \deduced Type of the third argument.
-     * \tparam T4 \deduced Type of the fourth argument.
-     * \tparam T5 \deduced Type of the fifth argument.
-     * \tparam T6 \deduced Type of the sixth argument.
-     * \param [in] a1 the first argument
-     * \param [in] a2 the second argument
-     * \param [in] a3 the third argument
-     * \param [in] a4 the fourth argument
-     * \param [in] a5 the fifth argument
-     * \param [in] a6 the sixth argument
-     */
-    template <typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-    void SetArgs(T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6);
-    /**@}*/
+    template <typename... Args>
+    void SetArgs(Args... args);
 
     /**
      * Schedule the callback for a future time.
